package api.common.util;

import api.common.pojo.vo.system.DictVO;
import com.fasterxml.jackson.databind.JsonNode;

import java.util.*;

public class ObjectUtil {

    /**
     * 空值判断
     *
     * @param obj
     * @return
     */
    public static boolean isNull(Object obj) {
        boolean isNullFlag = true;
        if (obj != null) {
            if (obj instanceof List) {
                isNullFlag = isNull((List) obj);
            } else if (obj instanceof Set) {
                isNullFlag = isNull((Set) obj);
            } else if (obj instanceof Object[]) {
                isNullFlag = isNull((Object[]) ((Object[]) obj));
            } else if (obj instanceof Map) {
                isNullFlag = isNull((Map) obj);
            } else if (obj instanceof String) {
                isNullFlag = isNull((String) obj);
            } else if (obj instanceof Integer) {
                isNullFlag = isNull((Integer) obj);
            } else if (obj instanceof Boolean) {
                isNullFlag = isNull((Boolean) obj);
            } else if (obj instanceof StringBuffer) {
                isNullFlag = isNull((StringBuffer) obj);
            } else if (obj instanceof JsonNode) {
                isNullFlag = isNull((JsonNode) obj);
            } else {
                isNullFlag = false;
            }
        }
        return isNullFlag;
    }

    public static boolean isNotNull(Object obj) {
        return !isNull(obj);
    }

    public static boolean isNull(List<?> list) {
        return list == null || list.size() == 0 || list.get(0) == null;
    }

    public static boolean isNull(Set<?> set) {
        return set == null || set.size() == 0;
    }

    public static boolean isNull(Object[] objects) {
        return objects == null || objects.length == 0;
    }

    public static boolean isNull(Map<?, ?> map) {
        return map == null || map.isEmpty();
    }

    public static boolean isNull(String str) {
        return str == null || "".equals(str.trim()) || "null".equalsIgnoreCase(str.trim()) || "undefined".equalsIgnoreCase(str.trim());
    }

    public static boolean isNull(Integer integer) {
        return integer == null;
    }

    public static boolean isNull(Boolean bol) {
        return bol == null;
    }

    public static boolean isNull(StringBuffer buffer) {
        return buffer == null || buffer.length() == 0;
    }

    public static boolean isNull(JsonNode jsonNode) {
        return jsonNode.isNull() || jsonNode.isEmpty();
    }

    public static List<DictVO> DictListToTree(List<DictVO> list) {
        List<DictVO> treeList = new ArrayList<DictVO>();
        for (DictVO dictVO: list) {
            if("0".equals(dictVO.getPid())){
                treeList.add(findChildren(dictVO,list));
            }
        }
        return treeList;
    }

    private static DictVO findChildren(DictVO dictVO, List<DictVO> list) {
        for (DictVO node: list) {
            if(dictVO.getId().equals(node.getPid())){
                if(dictVO.getChildren() == null || dictVO.getChildren().size() == 0){
                    dictVO.setChildren(new ArrayList<DictVO>());
                }
                dictVO.getChildren().add(findChildren(node,list));
            }
        }
        return dictVO;
    }

}
